var mysql = require('mysql');
var http = require('http');
var io = require('socket.io');

var con=null;

var roomTimer = setInterval(retrieveRooms, 1000);


var server = http.createServer(function() {});
server.listen(3004);
var listener = io.listen(server);


var roomList = [];
var newRoomList = [];

var clients=[];
var seqNo = 0;

function retrieveRooms()
{

	  con = mysql.createConnection({
	  host: "localhost",
	  user: "phpmyadmin",
	  password: "bolle199",
	  database: "phpmyadmin"
	});

	con.connect(function(err) {
	  if (err) throw err;
//	  console.log("Connected!");
	  con.query("select SUBJECT, MAPIMAGE, MAINIMAGE from WHITEBOARD_ROOM", function (err, result) {
		 if (err) throw err;
		 var i;
		 newRoomList.splice(0,newRoomList.length);
		 for (i=0; i<result.length; i++)
		 { 
			 newRoomList.push({subject:result[i].SUBJECT, mapImage:result[i].MAPIMAGE, mainImage:result[i].MAINIMAGE});
//			 console.log(newRoomList[newRoomList.length-1]);
		 }
//		 console.log("Result: " + result);
		 compareRoomLists();
	  });
	  con.end();
	}); 
}

function findRoom(subjectName)
{
	var i;
	for (i=0; i<roomList.length; i ++)
	{
		if (roomList[i].subject == subjectName) return i;
	}
	return -1;
}
	
function compareRoomLists()
{
	var i;
	var roomIndex;
	var roomListHasChanged=false;
	if (roomList.length!=newRoomList.length)
	{
		roomListHasChanged=true;
	} else {
		for (i=0; i<newRoomList.length; i ++)
		{
			roomIndex=findRoom(newRoomList[i].subject);
			if (roomIndex==-1) 
			{ 
				roomListHasChanged=true;
				i = newRoomList.lenght;
			} else {
				if ((newRoomList[i].mapImage != roomList[roomIndex].mapImage) || (newRoomList[i].mainImage != roomList[roomIndex].mainImage)) roomListHasChanged=true;
			}
		}
	}
	if (roomListHasChanged==true) renewRoomList();
}

function renewRoomList()
{
	var i;
	console.log("renewRoomList");
	console.log(newRoomList.length);
	roomList.splice(0,roomList.length);
	for (i=0;i<newRoomList.length; i++)
	{
		roomList.push({subject:newRoomList[i].subject, mainImage:newRoomList[i].mainImage, mapImage:newRoomList[i].mapImage, examList:[], responseList:[], helpList:[]}); 
      console.log(roomList[roomList.length-1]);
      console.log(i);
	}
}



function findClient(name)
{
	var i;
	console.log(clients.length);
	for (i=0;i<clients.length;i++)
	{
//		console.log("Testing client "+i+" of " + clients.length + " Is *" + clients[i].account.accountName + "* == *"+name + "*"); 
		if (clients[i].account.accountName==name) return i;
	}
	return -1;
}

function addClient(clientAccount,websocket)
{
   clients.push({account:clientAccount, socket:websocket});
}	

function deleteClient(name)
{
	var i;
	for (i=0;i<clients.length;i++)
	{
		if (clients[i].account.accountName==name)
		{
			clients.splice(i,1);
      	console.log(clients.length);
			return;
		}
	}
	return -1;
}

function deleteEntry(list,listEntry)
{
	var i;
	for (i=0; i<list.length; i++)
	{
		if (list[i].seqNo==listEntry.seqNo)
		{
			list.splice(i,1);
			return;
		}
	}
}

function modifyEntry(list,listEntry)
{
	var i;
	for (i=0; i<list.length; i++)
	{
		if (list[i].seqNo==listEntry.seqNo)
		{
			list.splice(i,1,listEntry);
			return;
		}
	}
}



listener.sockets.on('connection', function(socket) {
	console.log("Connection");
	socket.emit('youAreConnected', {'message': 'Connected to the Whiteboard WS server'});
	
	var account;
	var room="";
	var matchName="";
	var playerName="";
	var idExist=false;
	
    socket.on('idToServer',function(clientAccount) {
		 var clientNumber;
//		 console.log(clientAccount);
		 clientNumber=findClient(clientAccount.accountName);
//		 console.log(clientNumber);
		 if (clientNumber==-1)
		 {
//  		    console.log("New client " + clientAccount.accountName);
			 addClient(clientAccount, socket);
		 }
		 account=clientAccount;
		 idExist=true;
	 });

    socket.on('joinRoom',function(newRoom) {
		 var roomNumber;
		 if (room!="") {socket.leave(room);}
		 room="";
		 roomNumber = findRoom(newRoom);
		 if (roomNumber!=-1)
		 {
			 room=newRoom;
			 socket.join(newRoom);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });
	 
    socket.on('pollLists',function() {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });
	 
    socket.on('leaveRoom',function() {
		 if (room!="") {socket.leave(room);}
		 room="";
	 });

 	 socket.on('disconnect', function(data) {
		 if (room!="") {socket.leave(room);}
		 room="";
		 if (idExist==true) deleteClient(account.accountName);
	 });
	 
 	 socket.on('addItemToExamList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 listEntry.seqNo=seqNo++;
			 roomList[roomNumber].examList.push(listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

 	 socket.on('addItemToResponseList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 listEntry.seqNo=seqNo++;
			 roomList[roomNumber].responseList.push(listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

 	 socket.on('addItemToHelpList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 listEntry.seqNo=seqNo++;
			 roomList[roomNumber].helpList.push(listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

    socket.on('sendAlertToAccount',function(accountName,alertText) {
		 var clientNumber;
		 clientNumber=findClient(accountName);
		 if (clientNumber==-1)
		 {
			 socket.emit('sendAlertFailed',accountName);
		 } else {
			 clients[clientNumber].socket.emit('alert',alertText);
			 socket.emit('sendAlertSuccess',accountName);
		 }
	 });

 	 socket.on('removeItemFromExamList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 deleteEntry(roomList[roomNumber].examList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

 	 socket.on('removeItemFromResponseList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 deleteEntry(roomList[roomNumber].responseList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });
	 
 	 socket.on('removeItemFromHelpList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 deleteEntry(roomList[roomNumber].helpList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

    socket.on('clearAllListsInRoom',function() {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 roomList[roomNumber].helpList.splice(0,roomList[roomNumber].helpList.length);
			 roomList[roomNumber].responseList.splice(0,roomList[roomNumber].responseList.length);
			 roomList[roomNumber].examList.splice(0,roomList[roomNumber].examList.length);	 
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

    socket.on('clearAllLists',function() {
		 var roomNumber;
		 for (roomNumber=0;roomNumber<roomList.length;roomNumber++)
		 {
			 roomList[roomNumber].helpList.splice(0,roomList[roomNumber].helpList.length);
			 roomList[roomNumber].responseList.splice(0,roomList[roomNumber].responseList.length);
			 roomList[roomNumber].examList.splice(0,roomList[roomNumber].examList.length);	 
			 socket.broadcast.to(roomList[roomNumber].subject).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
		 roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });


 	 socket.on('modifyItemInExamList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 modifyEntry(roomList[roomNumber].examList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });
 	 socket.on('modifyItemInResponseList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 modifyEntry(roomList[roomNumber].responseList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });
 	 socket.on('modifyItemInHelpList', function(listEntry) {
		 var roomNumber = findRoom(room);
		 if (roomNumber!=-1)
		 {
			 modifyEntry(roomList[roomNumber].helpList,listEntry);
			 socket.broadcast.to(room).emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
			 socket.emit('listUpdate',roomList[roomNumber].examList, roomList[roomNumber].responseList, roomList[roomNumber].helpList);
		 }
	 });

		

});

		
	
	
	

